/**
  ******************************************************************************
  * @file    Project/PT32F0xx_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32F0xx_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 
      
  /* Add your application code here
     */
	/* */
  NVIC_InitTypeDef NVIC_InitStruct;
	ADC_InitTypeDef  ADC_InitStruct;
	LED_InitTypeDef  LED_InitStruct;
  NVIC_InitStruct.NVIC_IRQChannel = PA_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/*PA11жΪ½ش*/
	GPIO_TriTypeConfig(CMSDK_PA, GPIO_Pin_11, GPIOTI_Trigger_Rising);
  /*ʹPA11ܽŵж*/
	GPIO_ITConfig(CMSDK_PA, GPIO_IT_ITE11, ENABLE);
	
	/*PB3ΪADCͨ*/
  GPIO_AnalogFunctionConfig(CMSDK_PB, GPIO_Pin_3, ENABLE);
	/*ܸͨ*/	
  GPIO_PinAFConfig(CMSDK_PF, GPIO_PinSource0, GPIO_AF_2);
  GPIO_PinAFConfig(CMSDK_PF, GPIO_PinSource1, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource0, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource1, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource2, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource3, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource4, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource5, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource6, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource9, GPIO_AF_2);	
	GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource10, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource1, GPIO_AF_2);	
	GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource2, GPIO_AF_2);	
	
	/*ADCĳʼ(ת)*/
  ADC_StructInit(&ADC_InitStruct);
	ADC_Init(ADC, &ADC_InitStruct);
	/*ADCĹʱΪϵͳʱӵİ˷Ƶ*/
	ADC_ClockModeConfig(ADC, ADC_ClockMode_SynClkDiv8);
	/*ADCתͨ*/
	ADC_ChannelConfig(ADC, ADC_Channel_10);
	/*ʼ*/	
	LED_StructInit(&LED_InitStruct);
  LED_Init(&LED_InitStruct);
	/*COMܽλHIGH SINK*/
  LED_HighSinkConfig(LED_COM0|LED_COM1|LED_COM2|LED_COM3, ENABLE);
	/*ʾ*/
  LED_Cmd(ENABLE);
	/*ʾֵʼ ȫʾΪ0*/
	LED_UpdataDisplay(LED_COM0, 0x00);
	LED_UpdataDisplay(LED_COM1, 0x00);
	LED_UpdataDisplay(LED_COM2, 0x00);
	LED_UpdataDisplay(LED_COM3, 0x00);	
  /* Infinite loop */
  while (1)
  {
	/*GPIOжڴÿADCת*/
  }
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
