/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/*Ŷ*/
#define    KEY1_GPIO_PORT          CMSDK_PA			   
#define    KEY1_GPIO_PIN		       GPIO_Pin_11
/*Ŷ*/
#define    BEEP_GPIO_PORT          CMSDK_PB			   
#define    BEEP_GPIO_PinSource		 GPIO_PinSource2

#define    KEY_STATU         GPIO_ReadInputDataBit(KEY1_GPIO_PORT, KEY1_GPIO_PIN)
#define    key_state_0       0
#define    key_state_1       1
#define    key_state_2       2
#define    key_state_3       3
 
#define    key_no 		       0
#define    key_click	       1
#define    key_double	       2
#define    key_long	         3

/* CLK_CNT : ʱӣFcksys/(psc+1) = 24M/(psc+1)*/
/*TIMER1ʱΪ1ms*/
#define            ADVANCE_TIM_PERIOD            (1000-1)
#define            ADVANCE_TIM_PSC               (24-1)
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
uint32_t cnt_1ms;

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	

		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
  UART_InitTypeDef UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

 /**
  * @brief  ÷Ĺ
  * @param  
  * @retval 
  */
void BEEP_Config(void)
{
  Beep_InitTypeDef  Beep_InitStruct;
	
	Beep_InitStruct.Prescaler = 3;
	Beep_InitStruct.Subdivide = BEEP_SUBDIV_X2;
  Beep_Init(&Beep_InitStruct);	
	GPIO_PinAFConfig(BEEP_GPIO_PORT, BEEP_GPIO_PinSource, GPIO_AF_0);
}
/**
  * @brief  ðõI/O
  * @param  
  * @retval 
  */
void Key_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
		
	//ѡ񰴼
	GPIO_InitStructure.GPIO_Pin = KEY1_GPIO_PIN; 
	// ðΪ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	//ʹýṹʼ
	GPIO_Init(KEY1_GPIO_PORT, &GPIO_InitStructure);
	
}

/**
  * @brief   ˫  
  * @param  key_input ȡܽ״̬
  * @retval 
  */
static uint8_t key_driver(uint8_t key_input)
{
	static uint8_t key_state_buffer1 = key_state_0;
	static uint8_t key_timer_cnt1 = 0;
	uint8_t key_return = key_no;
	uint8_t key;
  /*read the I/O states*/	
	key = key_input;
	
	switch(key_state_buffer1)
	{
		case key_state_0:
			if(key == 0)
				key_state_buffer1 = key_state_1;
			/*£״̬תȷ״̬*/
			break;			
		case key_state_1:
			if(key == 0)
			{
				key_timer_cnt1 = 0;
				key_state_buffer1 = key_state_2;
				/*Ȼڰ״̬
				ɣkey_timerʼ׼ʱ
				״̬лʱʱ״̬*/
			}
			else
			{
				/*Ѿ̧𣬻صʼ״̬*/
			  key_state_buffer1 = key_state_0;
			}

			/**/
			break;  			
		case key_state_2:
			if(key == 1) 
			{
				/*̧𣬲һclick*/
				key_return = key_click;
        /*תʼ״̬*/			
				key_state_buffer1 = key_state_0;
			}
			/*£ʱ1000ms*/
			else if(++key_timer_cnt1 >= 100)
			{
				/*ͻس¼*/
				key_return = key_long;
				/*תȴͷ״̬*/
				key_state_buffer1 = key_state_3;
			}
			break;
		/*ȴͷ*/
		case key_state_3:
      /*ͷ*/			
			if(key == 1)
			{
				/*лذʼ״̬*/
				key_state_buffer1 = key_state_0;
			}
			break;
	}
	return key_return;
}

/**
  * @brief  в㰴õײ㺯һΣ˫¼ж
  * @param  key_input ȡܽ״̬
  * @retval ϲȷ޼˫״̬
  */
uint8_t key_read(uint8_t key_input)
{
	static uint8_t key_state_buffer2 = key_state_0;
	static uint8_t key_timer_cnt2 = 0;
	uint8_t key_return = key_no;
	uint8_t key;
	
	key = key_driver(key_input);
	
	switch(key_state_buffer2)
	{
		case key_state_0:
			if(key == key_click)
			{
        /*һεأ¸״̬жǷ˫*/
				key_timer_cnt2 = 0;
				key_state_buffer2 = key_state_1;
			}
			else
			{
        /*޼ԭ¼*/
			  key_return = key;
			}
			break;
			
		case key_state_1:
			/*һεʱС500ms*/
			if(key == key_click)
			{
				/*˫¼صʼ״̬*/
				key_return = key_double;
				key_state_buffer2 = key_state_0;
			}
			else if(++key_timer_cnt2 >= 50)
			{
				/*500msڿ϶Ķ޼¼Ϊ1000ms*/
				/*1sǰײ㷵صĶ޼*/
				/*500msûٴγֵ¼ص¼*/
				key_return = key_click;
				/*سʼ״̬*/
				key_state_buffer2 = key_state_0;
			}
			break;
	}
	
	return key_return;
}
/**
  * @brief  ʱģʽ,ʱ1ms
  * @param  None
  * @retval None
  */
static void TIMER_Mode_Config(void)
{
  TIM_TimeBaseInitTypeDef TimeBaseInit;
	NVIC_InitTypeDef NVIC_InitStruct;
  /*ʹTIMER0NVIC*/
  NVIC_InitStruct.NVIC_IRQChannel = TIMER3_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);

	/* CNTʱ = Fcksys/(psc+1)*/
	TimeBaseInit.Prescaler = ADVANCE_TIM_PSC;
	/*ģʽΪϼ*/
	TimeBaseInit.CounterMode = TIM_CNT_MODE_UP;
	/*ƥĴ,ۼMR0+1Ƶʺһ»ж*/
	TimeBaseInit.MatchValue = ADVANCE_TIM_PERIOD;
	/*CountMR0,λ*/
	TimeBaseInit.OVRSTEN = ENABLE;
	/*ʼʱ*/
  TIM_TimeBaseInit(TIM3, &TimeBaseInit);
	/*ʹܶʱTCؼĴMR0ƥʱж*/	
	TIM_ITConfig(TIM3, TIM_INT_MR0, ENABLE);	
  /*PWM*/	
	TIM_Cmd(TIM3, ENABLE);
}

/*򵥵ʱ*/
static void Delay(__IO uint32_t nCount)	
{
	for(; nCount != 0; nCount--);
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */      
  /* Add your application code here
     */
  /*ʼ*/
	uint8_t key_value = 0;	
	UART_Config();
  /* ʼRGBʵ */
  LED_GPIO_Config();
  /*ʼ */	
	Key_GPIO_Config();
  /*ʼӿ */	
	BEEP_Config();
	  /*ʼʱ*/
	TIMER_Mode_Config();
  /* Infinite loop */

  while (1)
  {
		if(cnt_1ms>=10)
		{
			cnt_1ms=0;
			key_value = key_read(KEY_STATU);
			if(key_value != key_no)
			{
		  if(key_value==key_click)
			{
        Beep_SubDivConfig(BEEP_SUBDIV_X8);
        Beep_Cmd(ENABLE);
			}
			else if (key_value==key_double)
		  {	
        Beep_SubDivConfig(BEEP_SUBDIV_X4);
        Beep_Cmd(ENABLE);      				
			 }
			else
			{
        Beep_Cmd(DISABLE);				
			 }							
		 }
		}
   } 		 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
