/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */


void Software_Delay(void)
{
	uint8_t i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}


void CMP_GPIO_Init()
{
	//ñȽ0 PA3Ϊ룬PA4Ϊ  PA9ΪȽ
	GPIO_AnalogFunctionConfig(CMSDK_PA,GPIO_Pin_3,ENABLE);
	GPIO_AnalogFunctionConfig(CMSDK_PA,GPIO_Pin_4,ENABLE);
	GPIO_PinAFConfig(CMSDK_PA,GPIO_PinSource9,GPIO_AF_0);
}	


void CMP_User_Init()
{
  //Ƚʼ
	CMPOPA_InitTypeDef  CMPOPA_InitStruct;
	CMPOPA_InitStruct.CMP_FilterSampling=CMP_FSTIMES_NONE;  //Ƚ˲Ϊ   ˲ֱͨ
	CMPOPA_InitStruct.CMP_HSMode = ENABLE;                  //ģʽʹܿ
	CMPOPA_InitStruct.CMP_PolarityReversal =DISABLE;        //Ƚѡ    DISABLE=  ENABLE=Էת
	CMPOPA_InitStruct.CMP_PosInputSEL=CMP_REFSEL_PIN;       //ȽԴѡ   
	CMPOPA_InitStruct.CMP_Outputpos=DISABLE;                //Ƚ  DISABLE: P<=N     ENABLE: P>N    
	CMP_Init(CMPOPA0,&CMPOPA_InitStruct);
	CMPOPA_Cmd(CMPOPA0,ENABLE);
	
	CMPOPA_SetInitDelayValue(CMPOPA0,600);   //ʼʱ25us
	
}


void CMP_NVIC_Init()
{
  CMP_ITConfig(CMPOPA0,CMP_IT_FALL,ENABLE);
//	CMP_ITConfig(CMPOPA0,CMP_IT_RISE,ENABLE);
	NVIC_EnableIRQ(Comparator0_IRQn);
}

void CMP_LED_Init()
{
	
	GPIO_InitTypeDef   GPIO_InitStruct;
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_4|GPIO_Pin_5;
	GPIO_InitStruct.GPIO_PuPd= GPIO_PuPd_NOPULL;
	GPIO_InitStruct.GPIO_Mode= GPIO_OType_PP;
	GPIO_Init(CMSDK_PB,&GPIO_InitStruct);
	
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_8;
	GPIO_InitStruct.GPIO_PuPd= GPIO_PuPd_NOPULL;
	GPIO_InitStruct.GPIO_Mode= GPIO_OType_PP;
	GPIO_Init(CMSDK_PA,&GPIO_InitStruct);
	
	GPIO_SetBits(CMSDK_PA,GPIO_Pin_8);
  GPIO_SetBits(CMSDK_PB,GPIO_Pin_4);
  GPIO_SetBits(CMSDK_PB,GPIO_Pin_5);
	
	GPIO_ResetBits(CMSDK_PB,GPIO_Pin_4);
	Software_Delay();
	GPIO_SetBits(CMSDK_PB,GPIO_Pin_4);
	Software_Delay();
	Software_Delay();
	GPIO_ResetBits(CMSDK_PB,GPIO_Pin_5);
	Software_Delay();
	GPIO_SetBits(CMSDK_PB,GPIO_Pin_5);
}



int main(void)
{
  
	CMP_GPIO_Init();
  CMP_User_Init();
  CMP_NVIC_Init();
	Software_Delay();
  Software_Delay();
	CMP_LED_Init();
	
  while (1)
  {

  }
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
