/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "Demo_Main.h"
#include "stdio.h"
/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
uint16_t		adc_result=0x00;
uint8_t			LED_Output_Enable = 1;
uint8_t			SW_Falling_Trip = 0;
uint32_t		PWM_Period_IntCounter = 0;

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/**
  * @brief  ADCת10ΣȥֵСֵȡƽֵ     
  * @retval None
  */
uint16_t ADC_SWGetValue(void)
{
  uint8_t i;
  uint16_t PA_int_ADC_Data[10],PV_int_max,PV_int_min;
  uint32_t PV_long_temp=0;

  //ADCת                                       
  for(i=0;i<10;i++)
  {                                     
	while(!ADC_GetFlagStatus(ADC,ADC_FLAG_EOC));
	/*תɱʶλ*/	
	ADC_ClearFlag(ADC,ADC_FLAG_EOC);
	/*ȡADCת*/
	PA_int_ADC_Data[i]=ADC_GetConversionValue(ADC);
	PV_long_temp+=PA_int_ADC_Data[i];
  }                                          
	/*жСֵ*/
  PV_int_max=PA_int_ADC_Data[0];
  PV_int_min=PA_int_ADC_Data[0];
  for(i=0;i<10;i++)                          
  { 
	if(PA_int_ADC_Data[i]>PV_int_max)
	  PV_int_max=PA_int_ADC_Data[i]; 
	if(PA_int_ADC_Data[i]<PV_int_min)
	  PV_int_min=PA_int_ADC_Data[i];
  }                                             

  //ת
  return((PV_long_temp-PV_int_max-PV_int_min)/8);
}
/**
  * @brief  Сʱ
  * @param  ʱֵ
  * @retval None
  */
void delay(uint32_t tick)
{
  while(tick--);
}




void	Uart0_Init(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

void	Adc_Init(void)
{
	ADC_InitTypeDef  ADC_InitStruct;
	/*PB3ΪADCͨ*/
  GPIO_AnalogFunctionConfig(CMSDK_PB, GPIO_Pin_3, ENABLE);
	
	/*ADCĳʼ(תʱ)*/
	ADC_InitStruct.ADC_ContinuousConvMode = ENABLE;
	ADC_InitStruct.ADC_DataAlign = ADC_DataAlign_Right;
	ADC_InitStruct.ADC_ExternalTrigConv = ADC_ExternalTrigConv_Software;
	ADC_InitStruct.ADC_HighSpeedSampMode = ENABLE;
	ADC_Init(ADC, &ADC_InitStruct);
	/*ADCĹʱΪϵͳʱӵİ˷Ƶ*/
	ADC_ClockModeConfig(ADC, ADC_ClockMode_SynClkDiv8);
	/*ADCתͨ*/
	ADC_ChannelConfig(ADC, ADC_Channel_10);
}

void	Adc_Start(void)
{
  /*ADC蹦*/
  ADC_Cmd(ADC, ENABLE);
	/*ȴADC*/
  while(!ADC_GetFlagStatus(ADC,ADC_FLAG_ADRDY));		
  /* Infinite loop */
}

void	LED_7SEC_Init(void)
{
		LED_InitTypeDef  LED_InitStruct;
	/*ܸͨ*/	
  GPIO_PinAFConfig(CMSDK_PF, GPIO_PinSource0, GPIO_AF_2);
  GPIO_PinAFConfig(CMSDK_PF, GPIO_PinSource1, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource0, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource1, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource2, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource3, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource4, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource5, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource6, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource9, GPIO_AF_2);	
	GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource10, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource1, GPIO_AF_2);	
	GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource2, GPIO_AF_2);	

	/*ʼ*/	
	LED_StructInit(&LED_InitStruct);
  LED_Init(&LED_InitStruct);
	/*COMܽλHIGH SINK*/
  LED_HighSinkConfig(LED_COM0|LED_COM1|LED_COM2|LED_COM3, ENABLE);
	/*ʾ*/
  LED_Cmd(ENABLE);
	/*ʾֵʼ ȫʾΪ0*/
	LED_UpdataDisplay(LED_COM0, 0x00);
	LED_UpdataDisplay(LED_COM1, 0x00);
	LED_UpdataDisplay(LED_COM2, 0x00);
	LED_UpdataDisplay(LED_COM3, 0x00);
}


void PWM_GPIO_Config(void)
{	
  /* PA6ΪTIM1PWMɲܣPA9 PB0ΪPWM */	
//	GPIO_PinAFConfig(PWM1_BKIN_GPIO_Port, PWM1_BKIN_PinSource, GPIO_AF_1);
	//ch1
  GPIO_PinAFConfig(PWM0_CH1_GPIO_Port, PWM0_CH1_PinSource, GPIO_AF_0);
	//ch2
  GPIO_PinAFConfig(PWM0_CH2_GPIO_Port, PWM0_CH2_PinSource, GPIO_AF_0);
}

void TIMER0_Interrupt_Enable(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;
  /*ʹTIMER0NVIC*/
  NVIC_InitStruct.NVIC_IRQChannel = TIMER0_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/*ʹܶʱTCؼĴMR0ƥʱж*/	
	PWM_IntConfig(PWM0, PWM_INT_MR0, ENABLE);	
}


void PWM_Mode_Config(void)
{
  PWM_TimeBaseInitTypeDef  TimeBaseInit;
	PWM_OutputInitTypeDef OutInit;

	/*ƥĴ,ۼMR0+1Ƶʺһ»ж*/
	TimeBaseInit.CounterReload = ADVANCE_TIM_PERIOD;
	/* CNTʱ = Fcksys/(psc+1)*/
	TimeBaseInit.Prescaler = ADVANCE_TIM_PSC;
	/*ģʽΪϼ*/
	TimeBaseInit.CounterMode = PWM_CNT_MODE_UP;
	/*ģʽ -- мģʽ3·PWMź*/
	TimeBaseInit.CounterDirRv_EN = PWM_CounterDirRv_EN;
	/*ʼʱ*/
  PMW_TimeBaseInit(PWM0, &TimeBaseInit);
	
	//ʹж
	TIMER0_Interrupt_Enable();
	
  /* ΪPWMͨΪ2ͨ*/
	OutInit.Channel =PWM_CH_1;
  /* ΪPWMģʽTCֵռձƥĴֵ͵ƽͨ෴*/	
	OutInit.OutputMode = COMPAER_MODE1;
	 /* ûʹ*/
  OutInit.ControlN = PWM_CHNCTL_ENABLE;
	/* ʱ*/
	OutInit.DeathTime = ADVANCE_TIM_DeadTime;
	/* PWMʱƽ״̬ɲʱԼPWMδʹ֮ǰƽ״̬ɲ󻥲ͨƽȻ*/	
	OutInit.IdleState = PWM_IDLE_HIGH;
  /* PWMռձ P = (ADVANCE_TIM_PULSE+1) / (ADVANCE_TIM_PERIOD+1)*/	
	OutInit.CompareValue = PWM_CH1_DUTY_CYCLE;
	/*ʼPWM*/	
	PWM_OutputInit(PWM0, &OutInit);
	OutInit.CompareValue = PWM_CH2_DUTY_CYCLE;
	OutInit.Channel =PWM_CH_2;				/*PWM-ch2*/
	PWM_OutputInit(PWM0, &OutInit);
	OutInit.CompareValue = PWM_CH3_DUTY_CYCLE;

	/*ʹPWM*/	
	PWM_Cmd(PWM0, ENABLE);
}




void PWM_Init(void)
{
  PWM_GPIO_Config();
  PWM_Mode_Config();	
}

void LED_IO_Init(void)
{
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED_CH3_Pin;	

		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED_CH3_GPIO_Port, &GPIO_InitStructure);	
}

void	Switch_IO_Init(void)
{
  NVIC_InitTypeDef NVIC_InitStruct;
  GPIO_InitTypeDef  GPIO_InitStruct;	
  NVIC_InitStruct.NVIC_IRQChannel = PA_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	
	/*PA11жΪ½ش*/
	GPIO_TriTypeConfig(UserKey_GPIO_Port, UserKey_Pin, GPIOTI_Trigger_Rising_Falling);
  /*ʹPA11ܽŵж*/
	GPIO_ITConfig(UserKey_GPIO_Port, GPIO_IT_ITE11, ENABLE);
}

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 
      
  /* Add your application code here
     */
	/* */
	
	uint32_t pwmcnt;
	
	float adcBack;
	char 	uartbuffer[64];
	float voltage;
	uint16_t temp;
	Uart0_Init();
	LED_IO_Init();
	Switch_IO_Init();
	delay(1000);
  printf(" ....LEDÿʼ...\r\n");
	LED_7SEC_Init();
  printf(" ....ADCģ...\r\n");
	Adc_Init();
	printf(" ....LED PWM...\r\n");
	PWM_Init();
	printf(" ....ADC...\r\n");
	Adc_Start();
	
  printf(" ....ʾ...\r\n");
	adcBack = 0;
	LED_Output_Enable = 1;
	pwmcnt = 0;
  while (1)
  {
		/*ȡADCתʾ--*/
		adc_result = 	ADC_SWGetValue();
		LED_UpdataDisplay(LED_COM3,  adc_result%10);
		LED_UpdataDisplay(LED_COM2, (adc_result/10)%10);
		LED_UpdataDisplay(LED_COM1, (adc_result/100)%10);
		LED_UpdataDisplay(LED_COM0, (adc_result/1000)%10);
		//ADCתתɵѹʾ

		//ADѹ
		voltage = adc_result;
		voltage = voltage / 4096;
		voltage *= 3.3;
		temp = (uint16_t)(voltage * 100);
		if(adcBack != temp)
		{
			adcBack = temp;
			sprintf(uartbuffer,"ADCѹ:%.2f",voltage);
			printf("%s\r\n",uartbuffer);
		}
		
		
		//סLED3˸
		if(SW_Falling_Trip == 1)
		{
			if((PWM_Period_IntCounter - pwmcnt ) > 300)
			{
				pwmcnt = PWM_Period_IntCounter;
				LED_CH3_TOGGLE;
			}
		}
		delay(0x8FFFF);
  }
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
