/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/*Ŷ*/
#define    KEY1_GPIO_PORT    CMSDK_PA			   
#define    KEY1_GPIO_PIN		 GPIO_Pin_11

 /** ±ú
	*  Ϊ͵ƽ KEY_ON=0 KEY_OFF=1
	*  ΪߵƽѺóKEY_ON=1 KEY_OFF=0 
	*/
#define KEY_ON	0
#define KEY_OFF	1

//дFLASHʼַַ
#define WRITE_START_ADDR  ((uint32_t)0x00006E00)
#define WRITE_END_ADDR    ((uint32_t)0x00007600)
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/*msʱ*/
uint32_t time = 0; 
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	

		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
  UART_InitTypeDef UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}
/**
  * @brief  ðõI/O
  * @param  
  * @retval 
  */
void Key_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
		
	//ѡ񰴼
	GPIO_InitStructure.GPIO_Pin = KEY1_GPIO_PIN; 
	// ðΪ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	//ʹýṹʼ
	GPIO_Init(KEY1_GPIO_PORT, &GPIO_InitStructure);
	
}

 /*
 * Key_Scan
 *   Ƿа
 *   GPIOxx  ABCD E
 *		     GPIO_PinȡĶ˿λ 	
 *   KEY_OFF(û°)KEY_ON°
 */
uint8_t Key_Scan(CMSDK_GPIO_TypeDef* CMSDK_Px, uint16_t GPIO_Pin)
{			
	/*Ƿа */
	if(GPIO_ReadInputDataBit(CMSDK_Px, GPIO_Pin) == KEY_ON )  
	{	 
		/*ȴͷ */
		while(GPIO_ReadInputDataBit(CMSDK_Px,GPIO_Pin) == KEY_ON);   
		return 	KEY_ON;	 
	}
	else
		return KEY_OFF;
}

/**
  * @brief  ڲFLASHжд
  * @param  None
  * @retval None
  */
int InternalFlash_Test(void)
{
	uint32_t EraseCounter = 0x00; 	//¼Ҫҳ
	uint32_t Address = 0x00;				//¼дĵַ
	uint32_t Data = 0x3210ABCD;			//¼д
	uint32_t NbrOfPage = 0x00;			//¼дҳ
	
	FLASH_Status FLASHStatus = FLASH_COMPLETE; //¼ÿβĽ	
	TestStatus MemoryProgramStatus = PASSED;//¼Խ
	

  /* Ҫҳ */
  NbrOfPage = (WRITE_END_ADDR - WRITE_START_ADDR) / FLASH_PAGE_SIZE;

  /* б־λ */
  FLASH_ClearFlag(FLASH_FLAG_WREND | FLASH_FLAG_EREND | FLASH_FLAG_PREREND | FLASH_FLAG_CMDER | FLASH_FLAG_ADER);	

  /* ҳ*/
  for(EraseCounter = 0; (EraseCounter < NbrOfPage) && (FLASHStatus == FLASH_COMPLETE); EraseCounter++)
  {
    FLASHStatus = FLASH_ErasePage(WRITE_START_ADDR + (FLASH_PAGE_SIZE * EraseCounter));
  
	}
  
  /* ڲFLASHд */
  Address = WRITE_START_ADDR;

  while((Address < WRITE_END_ADDR) && (FLASHStatus == FLASH_COMPLETE))
  {
    FLASHStatus = FLASH_ProgramWord(Address, Data);
    Address = Address + 4;
  }
 
  /* дǷȷ */
  Address = WRITE_START_ADDR;

  while((Address < WRITE_END_ADDR) && (MemoryProgramStatus != FAILED))
  {
    if((*(__IO uint32_t*) Address) != Data)
    {
      MemoryProgramStatus = FAILED;
    }
    Address += 4;
  }
	return MemoryProgramStatus;
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 
      
  /* Add your application code here
     */

	/*ðGPIO*/
	Key_GPIO_Config();
  /*ʼUARTģʽΪ 19200 8-N-1*/
  UART_Config();
	/*ʼLED˿*/
	LED_GPIO_Config();
	LED_BLUE;
	printf("\r\n ӭʹ΢  PT32X031  塣\r\n");	
	printf("̰USERKEYʼڲFLASH\r\n");
  /* Infinite loop */

  while (1)
  {
		if( Key_Scan(KEY1_GPIO_PORT,KEY1_GPIO_PIN) == KEY_ON  )
		{
	    printf("ڽждڲFLASHʵ飬ĵȴ\r\n");
	
	    if(InternalFlash_Test()== PASSED)
	    {
		    LED_GREEN;
		    printf("дڲFLASHԳɹ\r\n");
	      printf("̰USERKEYʼڲFLASH\r\n");
	     }
	    else
	    {
		    printf("дڲFLASHʧ\r\n");
		    LED_RED;
	     }
		} 	 
  }
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
