/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "bsp_i2c_eeprom.h"
/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

uint16_t EEPROM_ADDRESS;
uint16_t EEPROM_ADDRESS_R;
static __IO uint32_t  I2CTimeout = I2CT_LONG_TIMEOUT;   


static uint32_t I2C_TIMEOUT_UserCallback(uint16_t errorCode);


/**
  * @brief  I2C I/O
  * @param  
  * @retval 
  */
static void I2C_GPIO_Config(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure; 
    
  /* I2C_SCLI2C_SDA*/
//  GPIO_PinAFConfig(EEPROM_I2C_SCL_PORT, GPIO_PinSource9, GPIO_AF_4);
//  GPIO_PinAFConfig(EEPROM_I2C_SDA_PORT, GPIO_PinSource10, GPIO_AF_4);
	  CMSDK_PA->ALTFUNCSET1 |= (5<<4);	   // PA9 SCL	
    CMSDK_PA->ALTFUNCSET1 |= (5<<8);	 // PA10	SDA		
	
}


/**
  * @brief  I2C ģʽ
  * @param  
  * @retval 
  */
static void I2C_Mode_Configu(void)
{
  I2C_InitTypeDef  I2C_InitStructure; 

	
	/* ߵƽȶ͵ƽݱ仯 SCL ʱߵռձ */
	
  I2C_InitStructure.I2C_OwnAddress =0; 
  I2C_InitStructure.I2C_Ack = ENABLE ;
	I2C_InitStructure.I2C_BroadCast = DISABLE;
	I2C_InitStructure.I2C_SCLK_DIV = I2C_SCLK_DIVX60;  
	/* I2C ʼ */
  I2C_Init(EEPROM_I2Cx, &I2C_InitStructure);
  
	/* ʹ I2C */
  I2C_Cmd(EEPROM_I2Cx, ENABLE);   
}


/**
  * @brief  I2C (EEPROM)ʼ
  * @param  
  * @retval 
  */
void I2C_EE_Init(void)
{

  I2C_GPIO_Config(); 
 
  I2C_Mode_Configu();

/* ͷļi2c_ee.hеĶѡEEPROM豸ַ */
#ifdef EEPROM_Block0_ADDRESS_R
  /* ѡ EEPROM Block0 д */
  EEPROM_ADDRESS = EEPROM_Block0_ADDRESS_W;
	EEPROM_ADDRESS_R = EEPROM_Block0_ADDRESS_R;
#endif

#ifdef EEPROM_Block1_ADDRESS_R  
	/* ѡ EEPROM Block1 д */
  EEPROM_ADDRESS = EEPROM_Block0_ADDRESS_W;
	EEPROM_ADDRESS_R = EEPROM_Block0_ADDRESS_R;
#endif

#ifdef EEPROM_Block2_ADDRESS_R  
	/* ѡ EEPROM Block2 д */
  EEPROM_ADDRESS = EEPROM_Block0_ADDRESS_W;
	EEPROM_ADDRESS_R = EEPROM_Block0_ADDRESS_R;
#endif

#ifdef EEPROM_Block3_ADDRESS_R  
	/* ѡ EEPROM Block3 д */
  EEPROM_ADDRESS = EEPROM_Block0_ADDRESS_W;
	EEPROM_ADDRESS_R = EEPROM_Block0_ADDRESS_R;
#endif
}

/**
  * @brief  ʱʱ
  * @param  
  * @retval 
  */
void  Delay_I2C(uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}
/**
  * @brief   едI2C EEPROM
  * @param   
  *		@arg pBuffer:ָ
  *		@arg WriteAddr:дַ
  *     @arg NumByteToWrite:дֽ
  * @retval  
  */
void I2C_EE_BufferWrite(uint8_t* pBuffer, uint8_t WriteAddr, uint16_t NumByteToWrite)
{
  uint8_t NumOfPage = 0, NumOfSingle = 0, Addr = 0, count = 0;

  Addr = WriteAddr % I2C_PageSize;
  count = I2C_PageSize - Addr;
  NumOfPage =  NumByteToWrite / I2C_PageSize;
  NumOfSingle = NumByteToWrite % I2C_PageSize;
 
  /* If WriteAddr is I2C_PageSize aligned  */
  if(Addr == 0) 
  {
    /* If NumByteToWrite < I2C_PageSize */
    if(NumOfPage == 0) 
    {
      I2C_EE_PageWrite(pBuffer, WriteAddr, NumOfSingle);
      I2C_EE_WaitEepromStandbyState();			
    }
    /* If NumByteToWrite > I2C_PageSize */
    else  
    {
      while(NumOfPage--)
      {
        I2C_EE_PageWrite(pBuffer, WriteAddr, I2C_PageSize);
    	  I2C_EE_WaitEepromStandbyState();				
        WriteAddr +=  I2C_PageSize;
        pBuffer += I2C_PageSize;				
      }

      if(NumOfSingle!=0)
      {
        I2C_EE_PageWrite(pBuffer, WriteAddr, NumOfSingle);
        I2C_EE_WaitEepromStandbyState();
      }
    }
  }
  /* If WriteAddr is not I2C_PageSize aligned  */
  else 
  {
    /* If NumByteToWrite < I2C_PageSize */
    if(NumOfPage== 0) 
    {
      I2C_EE_PageWrite(pBuffer, WriteAddr, NumOfSingle);
      I2C_EE_WaitEepromStandbyState();
    }
    /* If NumByteToWrite > I2C_PageSize */
    else
    {
      NumByteToWrite -= count;
      NumOfPage =  NumByteToWrite / I2C_PageSize;
      NumOfSingle = NumByteToWrite % I2C_PageSize;	
      
      if(count != 0)
      {  
        I2C_EE_PageWrite(pBuffer, WriteAddr, count);
        I2C_EE_WaitEepromStandbyState();
        WriteAddr += count;
        pBuffer += count;
      } 
      
      while(NumOfPage--)
      {				
        I2C_EE_PageWrite(pBuffer, WriteAddr, I2C_PageSize);
        I2C_EE_WaitEepromStandbyState();
        WriteAddr +=  I2C_PageSize;
        pBuffer += I2C_PageSize;  
      }
      if(NumOfSingle != 0)
      {
        I2C_EE_PageWrite(pBuffer, WriteAddr, NumOfSingle);
        I2C_EE_WaitEepromStandbyState();
      }
    }
  }  
}


/**
  * @brief   дһֽڵI2C EEPROM
  * @param   
  *		@arg pBuffer:ָ
  *		@arg WriteAddr:дַ 
  * @retval  
  */
uint32_t I2C_EE_ByteWrite(uint8_t* pBuffer, uint8_t WriteAddr) 
{
  /* Send STRAT condition */
  I2C_GenerateSTART(EEPROM_I2Cx, ENABLE);

  I2CTimeout = I2CT_FLAG_TIMEOUT;  
  /*ʼλ*/
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x8)  
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x08);
  } 
  
  I2CTimeout = I2CT_FLAG_TIMEOUT;
  /* Send EEPROM address for write */
	I2C_SendData(EEPROM_I2Cx, EEPROM_ADDRESS);  
  /*ģʽӻַдλɲܵACK*/
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x18)
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x18);
  }  
  /* Send the EEPROM's internal address to write to */
  I2C_SendData(EEPROM_I2Cx, WriteAddr);
  
  I2CTimeout = I2CT_FLAG_TIMEOUT;
  /*ģʽֽɲܵACKӦ */
  while(I2C_GetStatus(EEPROM_I2Cx)!=0x28)
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x28);
  } 
  
  /* Send the byte to be written */
  I2C_SendData(EEPROM_I2Cx, *pBuffer); 
  
  I2CTimeout = I2CT_FLAG_TIMEOUT;  
  /*ģʽֽɲܵACKӦ */
  while(I2C_GetStatus(EEPROM_I2Cx)!=0x28)
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x28);
  } 
  
  /* Send STOP condition */
  I2C_GenerateSTOP(EEPROM_I2Cx, ENABLE);
  
  return 1;
}


/**
  * @brief   EEPROMһдѭпдֽڣһдֽ
  *          ܳEEPROMҳĴСAT24C02ÿҳ8ֽ
  * @param   
  *		@arg pBuffer:ָ
  *		@arg WriteAddr:дַ
  *     @arg NumByteToWrite:дֽ
  * @retval  
  */
uint32_t I2C_EE_PageWrite(uint8_t* pBuffer, uint8_t WriteAddr, uint8_t NumByteToWrite)
{
  I2CTimeout = I2CT_LONG_TIMEOUT;
	printf("0x%02X ", I2C_GetStatus(EEPROM_I2Cx));
  while(I2C_GetStatus(EEPROM_I2Cx)!=0xF8)   
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0xF8);
  } 
  
  /* Send START condition */
  I2C_GenerateSTART(EEPROM_I2Cx, ENABLE);
  
  I2CTimeout = I2CT_FLAG_TIMEOUT;
  /*ʼλ*/
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x8)  
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x08);
  } 
  
  /* Send EEPROM address for write */
	I2C_SendData(EEPROM_I2Cx, EEPROM_ADDRESS);
	
  I2CTimeout = I2CT_FLAG_TIMEOUT;	
  /*ģʽӻַдλɲܵACK*/
  while((I2C_GetStatus(EEPROM_I2Cx) !=0x18))
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x18);
  }  
  /* Send the EEPROM's internal address to write to */    
  I2C_SendData(EEPROM_I2Cx, WriteAddr);  

  I2CTimeout = I2CT_FLAG_TIMEOUT;
  /*ģʽֽɲܵACKӦ */
  while(I2C_GetStatus(EEPROM_I2Cx)!=0x28)
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x28);
  } 

  /* While there is data to be written */
  while(NumByteToWrite--)  
  {
    /* Send the current byte */
    I2C_SendData(EEPROM_I2Cx, *pBuffer); 

    /* Point to the next byte to be written */
    pBuffer++; 
  
    I2CTimeout = I2CT_FLAG_TIMEOUT;

  /*ģʽֽɲܵACKӦ */
  while(I2C_GetStatus(EEPROM_I2Cx)!=0x28)
    {
      if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x28);
    } 
  }

  /* Send STOP condition */
  I2C_GenerateSTOP(EEPROM_I2Cx, ENABLE);
  Delay_I2C(10000); 
  return 1;
}


/**
  * @brief   EEPROMȡһ 
  * @param   
  *		@arg pBuffer:ŴEEPROMȡݵĻָ
  *		@arg WriteAddr:ݵEEPROMĵַ
  *     @arg NumByteToWrite:ҪEEPROMȡֽ
  * @retval  
  */
uint32_t I2C_EE_BufferRead(uint8_t* pBuffer, uint8_t ReadAddr, uint16_t NumByteToRead)
{  
  
  I2CTimeout = I2CT_LONG_TIMEOUT;
  
  while(I2C_GetStatus(EEPROM_I2Cx)!=0xF8)
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0xF8);
   } 
  /* Send START condition */
  I2C_GenerateSTART(EEPROM_I2Cx, ENABLE);
  
  I2CTimeout = I2CT_FLAG_TIMEOUT;
  /*ʼλ*/
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x8)  
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x08);
  } 
  /* Send EEPROM address for write */
	I2C_SendData(EEPROM_I2Cx, EEPROM_ADDRESS);
	
  I2CTimeout = I2CT_FLAG_TIMEOUT;	
  /*ģʽӻַдλɲܵACK*/
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x18)
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x18);
  }  

  /* Send the EEPROM's internal address to write to */
  I2C_SendData(EEPROM_I2Cx, ReadAddr);  
  
  I2CTimeout = I2CT_FLAG_TIMEOUT;
  /* Test on EV8 and clear it */
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x28)
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x28);
   }
	
  I2C_GenerateSTOP(EEPROM_I2Cx, ENABLE);
	Delay_I2C(50); 
  /* Send STRAT condition a second time */  
  I2C_GenerateSTART(EEPROM_I2Cx, ENABLE);
  
  I2CTimeout = I2CT_FLAG_TIMEOUT;
  /*ʼλ*/
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x8)  
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x08);
   }
    
  /* Send EEPROM address for write */
	I2C_SendData(EEPROM_I2Cx, EEPROM_ADDRESS_R);
	
  I2CTimeout = I2CT_FLAG_TIMEOUT;	
  /*ģʽӻַͶλɲܵACK*/
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x40)
  {
    if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x40);
  }  
  
  /* While there is data to be read */
  while(NumByteToRead)  
  {
    if(NumByteToRead == 1)
    {
      /* Disable Acknowledgement */
      I2C_AcknowledgeConfig(EEPROM_I2Cx, DISABLE);
      
      /* Send STOP Condition */
      I2C_GenerateSTOP(EEPROM_I2Cx, ENABLE);
	    Delay_I2C(50);
    }

    EEPROM_I2Cx->CCR = I2C_CCR_IS;
    I2CTimeout = I2CT_LONG_TIMEOUT;
    /*ֽڽ*/    
		while((I2C_GetStatus(EEPROM_I2Cx)!=0x50)&&(I2C_GetStatus(EEPROM_I2Cx)!=0x58))  
		{
			if((I2CTimeout--) == 0) return I2C_TIMEOUT_UserCallback(0x50);
		} 
     
      /* Read a byte from the EEPROM */
      *pBuffer = I2C_ReceiveData(EEPROM_I2Cx);

      /* Point to the next location where the byte read will be saved */
      pBuffer++; 
      
      /* Decrement the read bytes counter */
      NumByteToRead--;        

  }

  /* Enable Acknowledgement to be ready for another reception */
  I2C_AcknowledgeConfig(EEPROM_I2Cx, ENABLE);
  
    return 1;
}


/**
  * @brief  Wait for EEPROM Standby state 
  * @param  
  * @retval 
  */
void I2C_EE_WaitEepromStandbyState(void)      
{
  I2CTimeout = I2CT_LONG_TIMEOUT;
  do
  {
    /* Send START condition */
  I2C_GenerateSTART(EEPROM_I2Cx, ENABLE);
  I2CTimeout = I2CT_FLAG_TIMEOUT;
  /*ʼλ*/
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x8)  
  {
    if((I2CTimeout--) == 0) break;
  } 
    /* Send EEPROM address for write */
	I2C_SendData(EEPROM_I2Cx, EEPROM_ADDRESS);
  I2CTimeout = I2CT_FLAG_TIMEOUT;	
  /*ģʽӻַдλɲܵACK*/
  while(I2C_GetStatus(EEPROM_I2Cx) !=0x18)
  {
    if((I2CTimeout--) == 0) break;
  }  
  }while(I2C_GetStatus(EEPROM_I2Cx) !=0x18);
  /* STOP condition */    
  I2C_GenerateSTOP(EEPROM_I2Cx, ENABLE);
  Delay_I2C(20000); 	
}




/**
  * @brief  Basic management of the timeout situation.
  * @param  errorCode룬λĸڳ.
  * @retval 0ʾIICȡʧ.
  */
static  uint32_t I2C_TIMEOUT_UserCallback(uint16_t errorCode)
{
  /* Block communication and all processes */
  EEPROM_ERROR("\r\nI2C ȴʱ!errorCode = 0x%02x\r\n",errorCode);

  
  return 0;
}