/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "pt32x031_i2c.h"
#include <string.h>
/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
#define							SLAVE_ADDRESS									0x58
#define							MASTER_DEVADR_WRITE						(SLAVE_ADDRESS << 1)
#define							MASTER_DEVADR_READ						((SLAVE_ADDRESS << 1) | 0x01)
/* Private define ------------------------------------------------------------*/
/**************************Master I2C********************************/
#define             MASTER_I2Cx                                I2C0   
#define							DEMO_Master_I2C_IRQn											 I2C0_IRQn
#define             MASTER_I2C_SCL_PORT                        CMSDK_PF 
#define             MASTER_I2C_SCL_PIN                         GPIO_Pin_1
#define             MASTER_I2C_SCL_PINSOURCE                   GPIO_PinSource1
#define             MASTER_I2C_SDA_PORT                        CMSDK_PF
#define             MASTER_I2C_SDA_PIN                         GPIO_Pin_0
#define             MASTER_I2C_SDA_PINSOURCE                   GPIO_PinSource0
/**************************slave I2C********************************/
#define             SLAVE_I2Cx                                I2C1   
#define							DEMO_slave_I2C_IRQn												I2C1_IRQn
#define             SLAVE_I2C_SCL_PORT                        CMSDK_PA 
#define             SLAVE_I2C_SCL_PIN                         GPIO_Pin_9
#define             SLAVE_I2C_SCL_PINSOURCE                   GPIO_PinSource9
#define             SLAVE_I2C_SDA_PORT                        CMSDK_PA
#define             SLAVE_I2C_SDA_PIN                         GPIO_Pin_10
#define             SLAVE_I2C_SDA_PINSOURCE                   GPIO_PinSource10
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
//Master IIC 
uint8_t	mI2C_TestWrite_Buffer[I2C_BUFSIZE];
uint8_t	mI2C_TestRead_Buffer[I2C_BUFSIZE];
//Slave IIC 
uint8_t	sI2C_TestWrite_Buffer[I2C_BUFSIZE];
uint8_t	sI2C_TestRead_Buffer[I2C_BUFSIZE];

void Delay(__IO uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	

		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;
	  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
	
	
	//DEMOIICû,ΪֱͨIO˿ڸIIC蹩--PA9,PA10˴Ҫ10KDEMOԭͼ
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;	
		GPIO_Init(CMSDK_PA, &GPIO_InitStructure);	
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;	
		GPIO_Init(CMSDK_PA, &GPIO_InitStructure);	
	
		CMSDK_PA->DATAOUT |= 0x0900;
}

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

/**
  * @brief  I2C I/O
  * @param  
  * @retval 
  */
static void masterI2C_GPIO_Config(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure; 
    
  /* I2C_SCLI2C_SDA*/
  GPIO_PinAFConfig(MASTER_I2C_SCL_PORT, MASTER_I2C_SCL_PINSOURCE, GPIO_AF_1);
  GPIO_PinAFConfig(MASTER_I2C_SDA_PORT, MASTER_I2C_SDA_PINSOURCE, GPIO_AF_1);
//	  CMSDK_PA->ALTFUNCSET1 |= (5<<4);	   // PA9 SCL	
//    CMSDK_PA->ALTFUNCSET1 |= (5<<8);	 // PA10	SDA		
   GPIO_PullUpConfig(CMSDK_PA, MASTER_I2C_SCL_PIN, ENABLE);
   GPIO_PullUpConfig(CMSDK_PA, MASTER_I2C_SDA_PIN, ENABLE);	
}


/**
  * @brief  I2C ģʽ
  * @param  
  * @retval 
  */
static void masterI2C_Mode_Configu(void)
{
  I2C_InitTypeDef  I2C_InitStructure; 

  I2C_InitStructure.I2C_OwnAddress =0; 
  I2C_InitStructure.I2C_Ack = ENABLE ;
	I2C_InitStructure.I2C_BroadCast = DISABLE;
	I2C_InitStructure.I2C_SCLK_DIV = I2C_SCLK_DIVX60;  
	/* I2C ʼ */
//  I2C_Init(MASTER_I2Cx, &I2C_InitStructure);
//	/* ʹ I2C */
//  I2C_Cmd(MASTER_I2Cx, ENABLE);   
	
	I2C_InitStructure.I2Cx_IRQn = DEMO_Master_I2C_IRQn;
	
	I2C_InitStructure.pWriteData = mI2C_TestWrite_Buffer;
	I2C_InitStructure.pReadData = mI2C_TestRead_Buffer;

	I2C_InitStructure.ReadDatalength = 0;
	I2C_InitStructure.WriteDataLength = 0;
  i2cInit(MASTER_I2Cx ,&I2C_InitStructure);
}


//I2C ģʽģ
void I2C_Master_Init(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;

  masterI2C_GPIO_Config();						//IIC GPIO configure
  masterI2C_Mode_Configu();						//IIC module configure

	NVIC_InitStruct.NVIC_IRQChannel = DEMO_Master_I2C_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);

}



static void slaveI2C_GPIO_Config(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure; 
    
  /* I2C_SCLI2C_SDA*/
  GPIO_PinAFConfig(SLAVE_I2C_SCL_PORT, SLAVE_I2C_SCL_PINSOURCE, GPIO_AF_4);
  GPIO_PinAFConfig(SLAVE_I2C_SDA_PORT, SLAVE_I2C_SDA_PINSOURCE, GPIO_AF_4);
	
  GPIO_PullUpConfig(SLAVE_I2C_SCL_PORT, SLAVE_I2C_SCL_PIN, ENABLE);
  GPIO_PullUpConfig(SLAVE_I2C_SDA_PORT, SLAVE_I2C_SDA_PIN, ENABLE);	
}

static void slaveI2C_Mode_Configu(void)
{
  I2C_InitTypeDef  I2C_InitStructure; 

	
	/* ߵƽȶ͵ƽݱ仯 SCL ʱߵռձ */
	
  I2C_InitStructure.I2C_OwnAddress = SLAVE_ADDRESS; 
  I2C_InitStructure.I2C_Ack = ENABLE ;
	I2C_InitStructure.I2C_BroadCast = DISABLE;
	I2C_InitStructure.I2C_SCLK_DIV = I2C_SCLK_DIVX60;    
	I2C_InitStructure.I2Cx_IRQn = DEMO_slave_I2C_IRQn;
	I2C_InitStructure.pWriteData = sI2C_TestWrite_Buffer;
	I2C_InitStructure.pReadData = sI2C_TestRead_Buffer;

	I2C_InitStructure.ReadDatalength = 0;
	I2C_InitStructure.WriteDataLength = 0;
	i2cInit(SLAVE_I2Cx ,&I2C_InitStructure);
}

static void I2C_Slave_Init(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;
  slaveI2C_GPIO_Config(); 
  slaveI2C_Mode_Configu();
	
	NVIC_InitStruct.NVIC_IRQChannel = DEMO_slave_I2C_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x01;
	NVIC_Init(&NVIC_InitStruct);
}

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
	int i;
  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 
      
  /* Add your application code here
     */
  /* ʼRGBʵ */
  LED_GPIO_Config();
	I2C_Master_Init();
	I2C_Slave_Init();

  /* Infinite loop */
	for(i=0;i<I2C_BUFSIZE;i++)
	{
		mI2C_TestWrite_Buffer[i] = i+1;
		sI2C_TestWrite_Buffer[i] = i+100;
	}
		LED2_ON;
	
  while (1)
  {
		Delay(2000);

		//IIC Master ֱдݣݳΪI2C_BUFSIZE
	for(i=0;i<I2C_BUFSIZE;i++)
	{
		sI2C_TestRead_Buffer[i] = 0;
		mI2C_TestRead_Buffer[i] = 0;
	}

		i2cMaster_TransmitStart(MASTER_I2Cx,MASTER_DEVADR_WRITE,mI2C_TestWrite_Buffer,I2C_BUFSIZE);
		
		for(i=0;i<I2C_BUFSIZE;i++)
		{
			if(mI2C_TestWrite_Buffer[i] != sI2C_TestRead_Buffer[i])
			{
				LED2_OFF;
				while(1)
				{
					Delay(100000);
					LED1_ON;
					Delay(100000);
					LED1_OFF;
				};
			}
		}

		//IIC Master ݣݳΪI2C_BUFSIZE
		Delay(2000);

		i2cMaster_TransmitStart(MASTER_I2Cx,MASTER_DEVADR_READ,mI2C_TestRead_Buffer,I2C_BUFSIZE);
		
		for(i=0;i<I2C_BUFSIZE;i++)
		{
			if(mI2C_TestRead_Buffer[i] != sI2C_TestWrite_Buffer[i])
			{
				LED2_OFF;
				while(1)
				{
					Delay(100000);
					LED1_ON;
					Delay(100000);
					LED1_OFF;
				};
			}
		}
	  }
		LED2_ON;
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
