/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* CLK_CNT : ʱӣFcksys/(psc+1) = 24M/(psc+1)*/
/*TIMER1ʱΪ1ms*/
#define            ADVANCE_TIM_PERIOD            (1000-1)
#define            ADVANCE_TIM_PSC               (24-1)
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/*msʱ*/
uint32_t time = 0; 
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	

		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
  UART_InitTypeDef UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}
 
/**
  * @brief  ʱģʽ
  * @param  None
  * @retval None
  */
static void TIMER_Mode_Config(void)
{
  PWM_TimeBaseInitTypeDef  TimeBaseInit;
	NVIC_InitTypeDef NVIC_InitStruct;
  /*ʹTIMER0NVIC*/
  NVIC_InitStruct.NVIC_IRQChannel = TIMER0_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/*ƥĴ,ۼMR0+1Ƶʺһ»ж*/
	TimeBaseInit.CounterReload = ADVANCE_TIM_PERIOD;
	/* CNTʱ = Fcksys/(psc+1)*/
	TimeBaseInit.Prescaler = ADVANCE_TIM_PSC;
	/*ģʽΪϼ*/
	TimeBaseInit.CounterMode = PWM_CNT_MODE_UP;
	/*رսģʽ*/
	TimeBaseInit.CounterDirRv_EN = PWM_CounterDirRv_DIS;
	/*ʼʱ*/
  PMW_TimeBaseInit(PWM0, &TimeBaseInit);
	/*ʹܶʱTCؼĴMR0ƥʱж*/	
	PWM_IntConfig(PWM0, PWM_INT_MR0, ENABLE);	
  /*PWM*/	
	PWM_Cmd(PWM0, ENABLE);

}


/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 
      
  /* Add your application code here
     */
  /*ʼ*/
	UART_Config();
  /* ʼRGBʵ */
  LED_GPIO_Config();
  /*ʼʱ*/
	TIMER_Mode_Config();
  /* Infinite loop */
  while (1)
  {
    /* 1000 * 1 ms = 1s ʱ䵽 */
    if ( time == 1000 ) 
    {
      time = 0;
			/* LED1 ȡ */      
			LED1_TOGGLE; 
    }        
   } 		 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
