/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define PWM1_CH4_GPIO_Port               CMSDK_PA
#define PWM1_CH4_PinSource               GPIO_PinSource11
#define PWM1_CH4_Pin                     GPIO_Pin_11

/*TIMER1ʱΪ100K*/
#define            ADVANCE_TIM_PERIOD            0xFFFF
#define            ADVANCE_TIM_PSC               239
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;
		/*ûմ*/
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

 /**
  * @brief  USART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
  UART_InitTypeDef UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

 /**
  * @brief   IOΪEXTIжϿڣжȼ
  * @param  
  * @retval 
  */
void EXTI_Key_Config(void)
{
  NVIC_InitTypeDef NVIC_InitStruct;
  GPIO_InitTypeDef  GPIO_InitStruct;	
  NVIC_InitStruct.NVIC_IRQChannel = PA_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/*ðõPA11жΪ½ش*/
	GPIO_TriTypeConfig(CMSDK_PA, GPIO_Pin_11, GPIOTI_Trigger_Falling);
  /*ʹܰõPA11ܽŵж*/
	GPIO_ITConfig(CMSDK_PA, GPIO_IT_ITE11, ENABLE);
}

 /**
  * @brief  ʱ
  * @param  
  * @retval 
  */
static void Delay(__IO uint32_t nCount)	 
{
	for(; nCount != 0; nCount--);
}

/**
  * @brief  ʼPWMܽ
  * @param  None
  * @retval None
  */
static void Capture_GPIO_Config(void)
{	
  /* PA11ΪTIM1벶 */	
  GPIO_PinAFConfig(PWM1_CH4_GPIO_Port, PWM1_CH4_PinSource, GPIO_AF_1);
}

/**
  * @brief  ģʽ
  * @param  None
  * @retval None
  */
static void Capture_Mode_Config(void)
{
  /*ʹTIMER1NVIC*/
  NVIC_InitTypeDef NVIC_InitStruct;
  NVIC_InitStruct.NVIC_IRQChannel = TIMER1_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/*TIMER1ͨ4زܴ*/
	PWM_RE_CaptureConfig(PWM1, PWM_CH_4, ENABLE);
	/*TIMER1ͨ4زжʹ*/
  PWM_CapITConfig(PWM1, PWM_INT_CAP4, ENABLE);
	/*ʹܶʱTCؼĴMR0ƥʱж*/	
	PWM_IntConfig(PWM1, PWM_INT_MR0, ENABLE);
	/*ʼTIMER1ĶʱΪ100KHZµĶʱʱ*/
  PWM_PrescalerConfig(PWM1, ADVANCE_TIM_PSC);
	PWM_SetCounterReload(PWM1, ADVANCE_TIM_PERIOD);

}

/**
  * @brief  ܳʼ
  * @param  None
  * @retval None
  */
static void Capture_Config(void)
{
  Capture_GPIO_Config();
	Capture_Mode_Config();
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32x031.c file
     */ 
      
  /* Add your application code here
     */
  /* ʼRGBʵ */
  LED_GPIO_Config();
	/*ʼΪжģʽжϺжϷ*/
	EXTI_Key_Config();
	/*ʼUART0*/
  UART_Config();
  /*ʼ*/
	Capture_Config();
  	
	printf("\r\n ӭʹ΢  PT32F0XX  塣\r\n");
  printf("\r\n PT32F0XX ߼ʱ\r\n");
	
	printf("\r\n ˵\r\n");

	printf("\r\n 1.USERKEYͨΪͨҲΪͨ\r\n");
	printf("\r\n 2.º̵ͬʱTIMER1ʱܣʼ벶\r\n");
	printf("\r\n 3.ɿ̵ͬʱͨڴӡնʾ\r\n");
  /* Infinite loop */
  while (1)
  {
	 /*GPIOжϺTIMER1жϺڴ¼*/
   } 		 
 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
