/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define UserKey_GPIO_Port                CMSDK_PA
#define UserKey_Pin                      GPIO_Pin_11

#define PWM1_CH1_GPIO_Port               CMSDK_PA
#define PWM1_CH1_PinSource               GPIO_PinSource8
#define PWM1_CH1_Pin                     GPIO_Pin_8

#define PWM1_CH1N_GPIO_Port              CMSDK_PA
#define PWM1_CH1N_PinSource              GPIO_PinSource7
#define PWM1_CH1N_Pin                    GPIO_Pin_7


#define PWM1_CH2_GPIO_Port               CMSDK_PA
#define PWM1_CH2_PinSource               GPIO_PinSource9
#define PWM1_CH2_Pin                     GPIO_Pin_9

#define PWM1_CH2N_GPIO_Port              CMSDK_PB
#define PWM1_CH2N_PinSource              GPIO_PinSource0
#define PWM1_CH2N_Pin                    GPIO_Pin_0

#define PWM1_CH3_GPIO_Port               CMSDK_PA
#define PWM1_CH3_PinSource               GPIO_PinSource10
#define PWM1_CH3_Pin                     GPIO_Pin_10

#define PWM1_CH3N_GPIO_Port              CMSDK_PB
#define PWM1_CH3N_PinSource              GPIO_PinSource1
#define PWM1_CH3N_Pin                    GPIO_Pin_1

#define PWM1_CH4_GPIO_Port               CMSDK_PA
#define PWM1_CH4_PinSource               GPIO_PinSource11
#define PWM1_CH4_Pin                     GPIO_Pin_11

#define PWM1_CH4N_GPIO_Port              CMSDK_PA
#define PWM1_CH4N_PinSource              GPIO_PinSource12
#define PWM1_CH4N_Pin                    GPIO_Pin_12


#define PWM1_BKIN_GPIO_Port              CMSDK_PA
#define PWM1_BKIN_PinSource              GPIO_PinSource6
#define PWM1_BKIN_Pin                    GPIO_Pin_6

/*PWM źŵƵ F = TIM_CLK/{(MR0+1)*(PSC+1)}*/
/*ĬõPWMΪ1M,ռձΪ50%,ʱ2*/
//PWMģʱԤƵ
#define            ADVANCE_TIM_PSC               (3-1)
//PWMģʱ䳣
#define            ADVANCE_TIM_DeadTime1           25
#define            ADVANCE_TIM_DeadTime2           10
#define            ADVANCE_TIM_DeadTime3           15
//PWMʱ䶨 -- MR0 ֵ
#define            ADVANCE_TIM_PERIOD            (250-1)
//PWM-ch1 ռձȳʼֵ -- MR1
#define            PWM_CH1_DUTY_CYCLE            ((ADVANCE_TIM_PERIOD * 1 / 4)-1)
//PWM-ch2 ռձȳʼֵ -- MR2
#define            PWM_CH2_DUTY_CYCLE            ((ADVANCE_TIM_PERIOD * 2 / 4)-1)
//PWM-ch3 ռձȳʼֵ -- MR3
#define            PWM_CH3_DUTY_CYCLE            ((ADVANCE_TIM_PERIOD * 3 / 4)-1)
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
uint16_t TimerPeriod = 0;
uint16_t Channel1Pulse = 0, Channel2Pulse = 0, Channel3Pulse = 0;
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		GPIO_InitTypeDef GPIO_InitStructure;
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	

		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);

		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 

}
 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
  UART_InitTypeDef UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

static void	app_ADC_Init(void)
{
  NVIC_InitTypeDef NVIC_InitStruct;
	ADC_InitTypeDef  ADC_InitStruct;
	
  GPIO_AnalogFunctionConfig(CMSDK_PB, GPIO_Pin_3, ENABLE);			/*PB3ΪADCͨ*/

	/*ADCĳʼ(תʱ)*/
	ADC_InitStruct.ADC_ContinuousConvMode = DISABLE;
	ADC_InitStruct.ADC_DataAlign = ADC_DataAlign_Right;									/* תҶ12bit */
	ADC_InitStruct.ADC_ExternalTrigConv = ADC_ExternalTrigConv_Timer1;	/* ѡTIMER1ΪԴ*/
	ADC_InitStruct.ADC_HighSpeedSampMode = ENABLE;
	ADC_Init(ADC, &ADC_InitStruct);
	
	ADC_ClockModeConfig(ADC, ADC_ClockMode_SynClkDiv8);						/*ADCĹʱΪϵͳʱӵİ˷Ƶ*/
	
	ADC_ChannelConfig(ADC, ADC_Channel_10);												/*ADCתͨ*/
	
	/*ʹADCж*/	
  NVIC_InitStruct.NVIC_IRQChannel = ADC_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
  ADC_ITConfig(ADC, ADC_IT_EOC, ENABLE);												/*ʹADCתж*/	
}


/**
  * @brief  ʼPWMܽ
  * @param  None
  * @retval None
  */
static void PWM_GPIO_Config(void)
{	
  /* PA6ΪTIM1PWMɲܣPA9 PB0ΪPWM */	
//	GPIO_PinAFConfig(PWM1_BKIN_GPIO_Port, PWM1_BKIN_PinSource, GPIO_AF_1);
	//ch1
  GPIO_PinAFConfig(PWM1_CH1_GPIO_Port, PWM1_CH1_PinSource, GPIO_AF_1);
  GPIO_PinAFConfig(PWM1_CH1N_GPIO_Port, PWM1_CH1N_PinSource, GPIO_AF_1);
	//ch2
  GPIO_PinAFConfig(PWM1_CH2_GPIO_Port, PWM1_CH2_PinSource, GPIO_AF_1);
  GPIO_PinAFConfig(PWM1_CH2N_GPIO_Port, PWM1_CH2N_PinSource, GPIO_AF_1);
	//CH3
  GPIO_PinAFConfig(PWM1_CH3_GPIO_Port, PWM1_CH3_PinSource, GPIO_AF_1);
  GPIO_PinAFConfig(PWM1_CH3N_GPIO_Port, PWM1_CH3N_PinSource, GPIO_AF_1);
	
	//CH4
  GPIO_PinAFConfig(PWM1_CH4_GPIO_Port, PWM1_CH4_PinSource, GPIO_AF_1);
  GPIO_PinAFConfig(PWM1_CH4N_GPIO_Port, PWM1_CH4N_PinSource, GPIO_AF_1);
	
//	/* PA6ڲ,£ôΪߵƽɲɲ*/
//  GPIO_PullDownConfig(PWM1_BKIN_GPIO_Port, PWM1_BKIN_Pin, ENABLE);	
}


/**
  ******************************************************************************
  * @note PWMź ںռձȵļ
  * MR0 ƥĴھPWM
  * MRx ռձƥĴھÿ·PWMռձ(x=1,2,3,4)
  * CLK_CNT : ʱӣFcksys/(psc+1) = 24M/(psc+1)
  * PWMźŵڣ T = (MR0+1) * (1/CLK_cnt) = (MR0+1)*(PSC+1) / 24M
  * PWMźŵռձȣP = (MRx+1) / (MR0+1)
  ******************************************************************************
  */
/**
  * @brief  PWMģʽ
  * @param  None
  * @retval None
  */
static void PWM_Mode_Config(void)
{
  PWM_TimeBaseInitTypeDef  TimeBaseInit;
	PWM_OutputInitTypeDef OutInit;

	NVIC_InitTypeDef NVIC_InitStruct;


	/*ƥĴ,ۼMR0+1Ƶʺһ»ж*/
	TimeBaseInit.CounterReload = ADVANCE_TIM_PERIOD;
	/* CNTʱ = Fcksys/(psc+1)*/
	TimeBaseInit.Prescaler = ADVANCE_TIM_PSC;
	/*ģʽΪϼ*/
	TimeBaseInit.CounterMode = PWM_CNT_MODE_UP;
	/*ģʽ -- мģʽ3·PWMź*/
	TimeBaseInit.CounterDirRv_EN = PWM_CounterDirRv_EN;
	/*ʼʱ*/
  PMW_TimeBaseInit(PWM1, &TimeBaseInit);
  /* ΪPWMͨΪ2ͨ*/
	OutInit.Channel =PWM_CH_1;
  /* ΪPWMģʽTCֵռձƥĴֵ͵ƽͨ෴*/	
	OutInit.OutputMode = COMPAER_MODE1;
	 /* ûʹ*/
  OutInit.ControlN = PWM_CHNCTL_ENABLE;
	/* ʱ*/
	OutInit.DeathTime = ADVANCE_TIM_DeadTime1;
	/* PWMʱƽ״̬ɲʱԼPWMδʹ֮ǰƽ״̬ɲ󻥲ͨƽȻ*/	
	OutInit.IdleState = PWM_IDLE_HIGH;
  /* PWMռձ P = (ADVANCE_TIM_PULSE+1) / (ADVANCE_TIM_PERIOD+1)*/	
	OutInit.CompareValue = PWM_CH1_DUTY_CYCLE;
	/*ʼPWM*/	
	PWM_OutputInit(PWM1, &OutInit);
	OutInit.DeathTime = ADVANCE_TIM_DeadTime2;
	OutInit.CompareValue = PWM_CH2_DUTY_CYCLE;
	OutInit.Channel =PWM_CH_2;				/*PWM-ch2*/
	PWM_OutputInit(PWM1, &OutInit);
	OutInit.DeathTime = ADVANCE_TIM_DeadTime3;
	OutInit.CompareValue = PWM_CH3_DUTY_CYCLE;
	OutInit.Channel =PWM_CH_3;				/*PWM-ch3*/
	PWM_OutputInit(PWM1, &OutInit);
	OutInit.DeathTime = ADVANCE_TIM_DeadTime1;
	OutInit.CompareValue = PWM_CH1_DUTY_CYCLE;
	OutInit.Channel =PWM_CH_4;				/*PWM-ch4*/
	PWM_OutputInit(PWM1, &OutInit);

	/*ʹPWM*/	
	PWM_Cmd(PWM1, ENABLE);
}
/**
  * @brief  ʼPWM
  * @param  None
  * @retval None
  */
static void PWM_Ini(void)
{
  PWM_GPIO_Config();
  PWM_Mode_Config();	
	ADC_Cmd(ADC, ENABLE);
	while(!ADC_GetFlagStatus(ADC,ADC_FLAG_ADRDY));
}

/**
  * @brief  ʱ
  * @param  None
  * @retval None
  */
static void Delay(__IO uint32_t nCount)	 //򵥵ʱ
{
	for(; nCount != 0; nCount--);
}

static void PWM_CH1CH4_UpdateDuty(void)
{
	static uint8_t flag = 0;
	static uint16_t duty = PWM_CH1_DUTY_CYCLE;
	if(flag == 0)
	{
		if(duty > 0)	duty --;
		else
		{
			flag = 1;
		}
	}
	else
	{
		if(duty < ADVANCE_TIM_PERIOD-1)
			duty++;
		else
		{
			flag = 0;
		}
	}
	if(duty > PWM1->MR0)
	{
		PWM1->MR4 = duty;
		PWM1->MR1 = duty;
	}
	else
	{
		PWM1->MR1 = duty;
		PWM1->MR4 = duty;
	}
}

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
	
		LED_GPIO_Config();	
		app_ADC_Init();
		PWM_Ini();
		LED1_OFF;			
	
	
		while (1)
		{
			Delay(3000);
			PWM_CH1CH4_UpdateDuty();
		}
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
 // printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
