/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
typedef enum { FAILED = 0, PASSED = !FAILED} TestStatus;
/* Private define ------------------------------------------------------------*/
/* ȡĳ */

/* Private macro -------------------------------------------------------------*/
#define				DEMO_master_SPIx								SPI0
#define				DEMO_master_SPIx_IRQn						SPI0_IRQn
#define				DEMO_slave_SPIx									SPI1
#define				DEMO_slave_SPIx_IRQn						SPI1_IRQn
//SPIģʽCSƷʽ
//#define SPIMASTER_GPIO_CS
#define	SPIMASTER_SOFT_CS
//#define	SPIMASTER_HW_CS
//---------------Master SPI ˿ڶ-------------------------------------------
//CS(NSS) ƬѡѡͨGPIO
#define      MASTER_SPI_CS_PORT                 CMSDK_PA
#define      MASTER_SPI_CS_PIN                  GPIO_Pin_4
#define      MASTER_SPI_CS_PINSOURCE            GPIO_PinSource4
//SCK
#define      MASTER_SPI_SCK_PORT                CMSDK_PA   
#define      MASTER_SPI_SCK_PIN                 GPIO_Pin_5
#define      MASTER_SPI_SCK_PINSOURCE           GPIO_PinSource5
//MISO
#define      MASTER_SPI_MISO_PORT                CMSDK_PA   
#define      MASTER_SPI_MISO_PIN                 GPIO_Pin_6
#define      MASTER_SPI_MISO_PINSOURCE           GPIO_PinSource6
//MOSI
#define      MASTER_SPI_MOSI_PORT                CMSDK_PA   
#define      MASTER_SPI_MOSI_PIN                 GPIO_Pin_7
#define      MASTER_SPI_MOSI_PINSOURCE           GPIO_PinSource7

#define SPI_MASTER_GPIOCS_HIGH									digitalHi(MASTER_SPI_CS_PORT,MASTER_SPI_CS_PIN)
#define SPI_MASTER_GPIOCS_LOW										digitalLo(MASTER_SPI_CS_PORT,MASTER_SPI_CS_PIN)


#define  		SPI_MASTER_CS_LOW()     						SPI_NSSInternalSoftwareConfig(DEMO_master_SPIx, SPI_NSSInternalSoft_Reset)
#define  		SPI_MASTER_CS_HIGH()    						SPI_NSSInternalSoftwareConfig(DEMO_master_SPIx, SPI_NSSInternalSoft_Set)

//---------------Slave SPI ˿ڶ-------------------------------------------
//CS(NSS) ƬѡѡͨGPIO
#define      SLAVE_SPI_CS_PORT                 CMSDK_PA
#define      SLAVE_SPI_CS_PIN                  GPIO_Pin_15
#define      SLAVE_SPI_CS_PINSOURCE            GPIO_PinSource15
//SCK
#define      SLAVE_SPI_SCK_PORT                CMSDK_PB   
#define      SLAVE_SPI_SCK_PIN                 GPIO_Pin_3
#define      SLAVE_SPI_SCK_PINSOURCE           GPIO_PinSource3
//MISO
#define      SLAVE_SPI_MISO_PORT                CMSDK_PB   
#define      SLAVE_SPI_MISO_PIN                 GPIO_Pin_4
#define      SLAVE_SPI_MISO_PINSOURCE           GPIO_PinSource4
//MOSI
#define      SLAVE_SPI_MOSI_PORT                CMSDK_PB  
#define      SLAVE_SPI_MOSI_PIN                 GPIO_Pin_5
#define      SLAVE_SPI_MOSI_PINSOURCE           GPIO_PinSource5
/* Private variables ---------------------------------------------------------*/
uint16_t spi_slave_TxLen = 0;
uint16_t spi_slave_TxIndex = 0;
uint8_t		slave_spi_RxComplete = 0;
uint8_t	master_spi_txBuf[DEMO_SPI_BUFFERSIZE];
uint8_t	master_spi_RxBuf[DEMO_SPI_BUFFERSIZE];
uint8_t	slave_spi_txBuf[DEMO_SPI_BUFFERSIZE];
uint8_t	slave_spi_RxBuf[DEMO_SPI_BUFFERSIZE];

/* Private variables ---------------------------------------------------------*/
__IO TestStatus TransferStatus1 = FAILED;
/* Private function prototypes -----------------------------------------------*/
void Delay(__IO uint32_t nCount);
TestStatus Buffercmp(uint8_t* pBuffer1, uint8_t* pBuffer2, uint16_t BufferLength);
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	

		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
	
	  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
		
				/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;	
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
	  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		GPIO_Init(CMSDK_PB, &GPIO_InitStructure);	
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;	
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
	  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		GPIO_Init(CMSDK_PB, &GPIO_InitStructure);	

}

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

/* Private functions ---------------------------------------------------------*/
/**
  * @brief  ģʽSPI_ģʼ
  * @param  
  * @retval 
  */
void SPI_Master_Init(CMSDK_SPI_TypeDef* SPIx)
{
  SPI_InitTypeDef  SPI_InitStructure;
  NVIC_InitTypeDef NVIC_InitStruct;

#ifdef SPIMASTER_GPIO_CS
	/*һGPIO_InitTypeDef͵Ľṹ*/
	GPIO_InitTypeDef GPIO_InitStructure;
	/*ѡҪƵGPIO*/
	GPIO_InitStructure.GPIO_Pin = MASTER_SPI_CS_PIN;	
	/*ģʽΪͨ*/
	GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	/*ÿ⺯ʼGPIO*/
	GPIO_Init(MASTER_SPI_CS_PORT, &GPIO_InitStructure);
	MASTER_SPI_CS_PORT->DATAOUT |= MASTER_SPI_CS_PIN;
#else
  /* SPIܽŵĸù */
  GPIO_PinAFConfig(MASTER_SPI_CS_PORT, MASTER_SPI_CS_PINSOURCE, GPIO_AF_0);			//CSΪӲԶģʽ
	SPI_MASTER_CS_HIGH();		//CSģ(ģʽӲģʽ)ݷɺCSԶߵƽ
#endif
  GPIO_PinAFConfig(MASTER_SPI_SCK_PORT, MASTER_SPI_SCK_PINSOURCE, GPIO_AF_0);
  GPIO_PinAFConfig(MASTER_SPI_MISO_PORT, MASTER_SPI_MISO_PINSOURCE, GPIO_AF_0);
  GPIO_PinAFConfig(MASTER_SPI_MOSI_PORT, MASTER_SPI_MOSI_PINSOURCE, GPIO_AF_0);
  /* SPI жʹ */
  NVIC_InitStruct.NVIC_IRQChannel = DEMO_master_SPIx_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
//	NVIC_Init(&NVIC_InitStruct);

  /* SPI ģʽ */
  /* SPI ʼ㹫ʽ(PT32F0XX SPI master ģʽ£ʱƵ10mHZ)
	    BPSSPI= fSYS/ (SPI_BaudRatePrescaler * (1+SPI_BaudRatePostPrescaler))
			: fSYS = 24000000,SPI_BaudRatePrescaler = 2,SPI_BaudRatePostPrescaler = 0  --> SPIΪ 12MHz
	*/
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_CR0_DSS_8B;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
#ifndef SPIMASTER_HW_CS
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
#else
  SPI_InitStructure.SPI_NSS = SPI_NSS_Hard;
#endif
  SPI_InitStructure.SPI_BaudRatePrescaler = 20;						//ע:ԤƵż
  SPI_InitStructure.SPI_BaudRatePostPrescaler = 0;
  SPI_Init(SPIx , &SPI_InitStructure);

/* ʹ SPI ͻ  */
//	SPI_ITConfig(SPIx, SPI_IT_TFHF, ENABLE);
  /* ʹ SPI  */
  SPI_Cmd(SPIx , ENABLE);	
}

/* Private functions ---------------------------------------------------------*/
/**
  * @brief  ģʽSPI_ģʼ
  * @param  
  * @retval 
  */
void SPI_Slave_Init(CMSDK_SPI_TypeDef* SPIx)
{
  NVIC_InitTypeDef NVIC_InitStruct;

  SPI_InitTypeDef  SPI_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;
  /* SPIܽŵĸù */
  GPIO_PinAFConfig(SLAVE_SPI_CS_PORT, SLAVE_SPI_CS_PINSOURCE, GPIO_AF_1);
  GPIO_PinAFConfig(SLAVE_SPI_SCK_PORT, SLAVE_SPI_SCK_PINSOURCE, GPIO_AF_1);
  GPIO_PinAFConfig(SLAVE_SPI_MISO_PORT, SLAVE_SPI_MISO_PINSOURCE, GPIO_AF_1);
  GPIO_PinAFConfig(SLAVE_SPI_MOSI_PORT, SLAVE_SPI_MOSI_PINSOURCE, GPIO_AF_1);
  /* SPI ģʽ */

  /* SPI ʼ㹫ʽ(PT32F0XX SPI slave ģʽ£ʱƵ2mHZ)
	    BPSSPI= fSYS/ (SPI_BaudRatePrescaler * (1+SPI_BaudRatePostPrescaler))
			: fSYS = 24000000,SPI_BaudRatePrescaler = 2,SPI_BaudRatePostPrescaler = 0  --> SPIΪ 12MHz
	*/
	
  NVIC_InitStruct.NVIC_IRQChannel = DEMO_slave_SPIx_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	//SPI
  SPI_InitStructure.SPI_Mode = SPI_Mode_Slave;
  SPI_InitStructure.SPI_DataSize = SPI_CR0_DSS_8B;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
#ifndef SPIMASTER_HW_CS
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
#else
  SPI_InitStructure.SPI_NSS = SPI_NSS_Hard;
#endif
  SPI_InitStructure.SPI_BaudRatePrescaler = 16;		//ע:ԤƵż
  SPI_InitStructure.SPI_BaudRatePostPrescaler = 0;
  SPI_Init(SPIx , &SPI_InitStructure);

	/*ʹжϽ -- SPIջǿж*/
	SPI_ClearFlag(SPIx, SPI_IT_RFNEOT);
	SPI_ITConfig(SPIx, SPI_IT_RFNEOT, ENABLE);	//SPI FIFOǿճʱж
	SPI_ITConfig(SPIx, SPI_IT_RFHF, ENABLE);		//SPI FIFOж

  /* ʹ SPI  */
  SPI_Cmd(SPIx , ENABLE);	
}

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
	int i;
	int temp;
	TestStatus retval;
  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 

  /* Add your application code here
     */
	/* ôΪ19200 8-N-1 */
	//UART- Ӳ,TX SPI1 CSųͻ(SLAVE ģʽ)UARTر
//	UART_Config();
//	printf("\r\n һSPIд - ѯģʽ \r\n");

  /* ʼRGBʵ */
  LED_GPIO_Config();	
	/*SPI Master ģʽûͨѯģʽдFIFO*/
	//SPI Master ģʼ
	SPI_Master_Init(DEMO_master_SPIx);
	/*SPI Slave ģʽóɽFIFOFIFOǿճʱжͬʱ*/
	//SPI Slave ģʼ
	SPI_Slave_Init(DEMO_slave_SPIx);
	
	for(i=0;i<DEMO_SPI_BUFFERSIZE;i++)
	{
		master_spi_txBuf[i] = i+1;
		slave_spi_txBuf[i] = i+100;
	}
	
	LED1_OFF;
	LED2_OFF;
	LED3_OFF;
	spi_slave_TxLen = DEMO_SPI_BUFFERSIZE;
  /* Infinite loop */
  while (1)
  {
			Delay( 1000 );
/***** Slave SPI Ԥ׼ -- SlaveFIFOж**************	*/
			spi_slave_TxIndex = 0;
			SPI_ITConfig(DEMO_slave_SPIx, SPI_IT_TFHF, ENABLE);		//SPI FIFOж
/***** Slave SPI Ԥ׼ -- SlaveFIFOж**************	*/
			for(i=0;i<DEMO_SPI_BUFFERSIZE;i++)
			{
				master_spi_RxBuf[i] = 0;
			}
			slave_spi_RxComplete = 0;
/***** Master SPI ݴ	*/
/***** Master SPI CSſ -- CS͵ƽݴ俪ʼ	*/
 			#ifdef SPIMASTER_GPIO_CS
				SPI_MASTER_GPIOCS_LOW;
			#endif
			#ifdef SPIMASTER_SOFT_CS
				SPI_MASTER_CS_LOW();
			#endif
/***** Master SPI ѯSR״̬ĴINTFλFIFOδд,Ӳͬʱʼ*/
/***** Master SPI ѯSR״̬ĴRFNEλͬʱ*/
			while(DEMO_master_SPIx->SR & SPI_SR_RFNE)
			{//FIFOǿ
				temp = DEMO_master_SPIx->DR;		//սFIFO
			}
			for(i=0;i<DEMO_SPI_BUFFERSIZE;i++)
			{
			   while(!(DEMO_master_SPIx->SR & SPI_FLAG_TFNF));
				DEMO_master_SPIx->DR = master_spi_txBuf[i];						//д뷢FIFO
				 while(!(DEMO_master_SPIx->SR & SPI_SR_RFNE));
				 //FIFOǿ
				 master_spi_RxBuf[i] = DEMO_master_SPIx->DR;		//ȡӴSlaveյ
			}
/***** Master SPI CSſ -- дɣCSߵƽ	*/
			#ifdef SPIMASTER_GPIO_CS
			while(1)
			{
				if((DEMO_master_SPIx->SR & 0X01) == 1)
					break;
			}
			SPI_MASTER_GPIOCS_HIGH;		//CSûƣSPIģ״̬ʱSPIߵƽݴ
			#endif
			#ifdef SPIMASTER_SOFT_CS
			SPI_MASTER_CS_HIGH();		//CSģ(ģʽӲģʽ)ݷɺCSԶߵƽ
			#endif
			while(slave_spi_RxComplete == 0){};		//ȴݽ
//֤
			retval = Buffercmp(master_spi_txBuf, slave_spi_RxBuf, DEMO_SPI_BUFFERSIZE);
			if(PASSED == retval)
			{//̵ݽУȷ
				LED2_ON;
				LED3_OFF;
			}
			else
			{//ݽУ
				LED3_ON;
				LED2_OFF;
			}
  }
}

/*
 * Buffercmp
 *   ȽеǷ
 *   -pBuffer1     srcָ
 *         -pBuffer2     dstָ
 *         -BufferLength 
 *   
 *   -PASSED pBuffer1    pBuffer2
 *         -FAILED pBuffer1 ͬ pBuffer2
 */
TestStatus Buffercmp(uint8_t* pBuffer1, uint8_t* pBuffer2, uint16_t BufferLength)
{
  while(BufferLength--)
  {
    if(*pBuffer1 != *pBuffer2)
    {
      return FAILED;
    }

    pBuffer1++;
    pBuffer2++;
  }
  return PASSED;
}

void Delay(__IO uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
//  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
