/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/*Ŷ*/
#define    KEY1_GPIO_PORT    CMSDK_PA			   
#define    KEY1_GPIO_PIN		 GPIO_Pin_11

 /** ±ú
	*  Ϊ͵ƽ KEY_ON=0 KEY_OFF=1
	*  ΪߵƽѺóKEY_ON=1 KEY_OFF=0 
	*/
#define KEY_ON	0
#define KEY_OFF	1
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/*msʱ*/
uint32_t time = 0; 
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	

		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
  UART_InitTypeDef UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}
/**
  * @brief  ðõI/O
  * @param  
  * @retval 
  */
void Key_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
		
	//ѡ񰴼
	GPIO_InitStructure.GPIO_Pin = KEY1_GPIO_PIN; 
	// ðΪ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	//ʹýṹʼ
	GPIO_Init(KEY1_GPIO_PORT, &GPIO_InitStructure);
	
}

 /*
 * Key_Scan
 *   Ƿа
 *   GPIOxx  ABCD E
 *		     GPIO_PinȡĶ˿λ 	
 *   KEY_OFF(û°)KEY_ON°
 */
uint8_t Key_Scan(CMSDK_GPIO_TypeDef* CMSDK_Px, uint16_t GPIO_Pin)
{			
	/*Ƿа */
	if(GPIO_ReadInputDataBit(CMSDK_Px, GPIO_Pin) == KEY_ON )  
	{	 
		/*ȴͷ */
		while(GPIO_ReadInputDataBit(CMSDK_Px,GPIO_Pin) == KEY_ON);   
		return 	KEY_ON;	 
	}
	else
		return KEY_OFF;
}
/*
 *  IWDG ĳʱʱ
 * Tout = 1/32.768 * rlv (ms)
 * rlv:ֵȡֵΧΪ0-0XFFFF
 * þ
 * IWDG_Config(32768);  // IWDG 1s ʱ
 * IWDGжΪжNMI
 */

void IWDG_Config(uint32_t rlv)
{	
	/*WDGĴ*/
	WDG_WriteAccessCmd(IWDG, WDG_WriteAccess_Enable);	
	/*װؼĴֵ*/
	WDG_SetReload(IWDG, rlv );	
	/*װؼĴֵŵ*/
	WDG_ReloadCounter(IWDG);
	/*Źλʹ*/
  WDG_RstCmd(IWDG, ENABLE);
	/*ʹ IWDG*/
	WDG_Cmd(IWDG, ENABLE);
	/*סWDGĴֹ*/
	WDG_WriteAccessCmd(IWDG, WDG_WriteAccess_Disable);	
}

/*ι*/
void IWDG_Feed(void)
{
	/*WDGĴ*/
	WDG_WriteAccessCmd(IWDG, WDG_WriteAccess_Enable);		
	/*װؼĴֵŵУιֹIWDGλ
	 *ֵ0ʱϵͳλ
	*/
	WDG_ReloadCounter(IWDG);
	/*סWDGĴֹ*/
	WDG_WriteAccessCmd(IWDG, WDG_WriteAccess_Disable);	
}
/*򵥵ʱ*/
static void Delay(__IO uint32_t nCount)	
{
	for(; nCount != 0; nCount--);
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32x031.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32x031.c file
     */ 
      
  /* Add your application code here
     */
  /*ʼ*/
	UART_Config();
  /* ʼRGBʵ */
  LED_GPIO_Config();
	
	Delay(0x300000);
	
	/* ǷΪŹλ */
  if (System_GetResetFlagStatus(RSTCU_FLAG_IWDTRST) != RESET)
  {
    /* Źλ */
    /*   */
    LED_RED;
    /* ־ */
    System_ClearResetFlag(RSTCU_FLAG_IWDTRST);		
		/*һֱιһֱλǰʱῴ˸
		1s ʱιĻ̵*/
  }
  else
  {
    /*ǶŹλ(Ϊϵ縴λֶλ֮) */
    /*  */
    LED_BLUE;
  }
	/*ðGPIO*/
	Key_GPIO_Config();
	/*IWDG 1s ʱ*/
	IWDG_Config(32768);
	/*whileĿоҪдĴ룬ⲿֵĳöŹ
    *֪ⲿִִʱ䣬500msôǿöŹ
	  *ʱ600ms500msһ㣬ҪصĳûִܷеĻô
	  *ִ֮ͻִιĳܷǳͻᳬʱﲻι
	  *ĳ,ʱͻϵͳλ
	*/
  /* Infinite loop */

  while (1)
  {
/* ҪصĴ룬оȥģιѰɨȥ*/
		if( Key_Scan(KEY1_GPIO_PORT,KEY1_GPIO_PIN) == KEY_ON  )
		{
			/* ιιϵͳḴλLED1һΣ1s
			 * ʱ׼ʱιĻ᳣̻*/
			IWDG_Feed();
			/*ι̵*/
			LED_GREEN;
		}   		
   } 		 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
